// Generated by CoffeeScript 1.9.3
var EventEmitter,
    Parser,
    StreamParser,
    extend = function (child, parent) {
  for (var key in parent) {
    if (hasProp.call(parent, key)) child[key] = parent[key];
  }function ctor() {
    this.constructor = child;
  }ctor.prototype = parent.prototype;child.prototype = new ctor();child.__super__ = parent.prototype;return child;
},
    hasProp = ({}).hasOwnProperty;

EventEmitter = require('events').EventEmitter;

StreamParser = require("./stream-parser");

/*
  Buffers are thrown at the parser (by calling addBuffer).
  Tokens are parsed from the buffer until there are no more tokens in
  the buffer, or there is just a partial token left.
  If there is a partial token left over, then it is kept until another
  buffer is added, which should contain the remainder of the partial
  token, along with (perhaps) more tokens.
  The partial token and the new buffer are concatenated, and the token
  parsing resumes.
 */

Parser = (function (superClass) {
  extend(Parser, superClass);

  function Parser(debug, colMetadata, options) {
    this.debug = debug;
    this.colMetadata = colMetadata;
    this.options = options;
    this.parser = new StreamParser(this.debug, this.colMetadata, this.options);
    this.parser.on("data", (function (_this) {
      return function (token) {
        if (token.event) {
          return _this.emit(token.event, token);
        }
      };
    })(this));
  }

  Parser.prototype.addBuffer = function (buffer) {
    return this.parser.write(buffer);
  };

  Parser.prototype.isEnd = function () {
    return this.parser.buffer.length === 0;
  };

  return Parser;
})(EventEmitter);

exports.Parser = Parser;