// Generated by CoffeeScript 1.9.3
var convertLEBytesToString, getNextRemainder, invert, isZero, numberToInt64LE;

isZero = function (array) {
  var byte, j, len;
  for (j = 0, len = array.length; j < len; j++) {
    byte = array[j];
    if (byte !== 0) {
      return false;
    }
  }
  return true;
};

getNextRemainder = function (array) {
  var index, j, ref, remainder, s;
  remainder = 0;
  for (index = j = ref = array.length - 1; j >= 0; index = j += -1) {
    s = remainder * 256 + array[index];
    array[index] = Math.floor(s / 10);
    remainder = s % 10;
  }
  return remainder;
};

invert = function (array) {
  var byte, index, j, k, len, len1, results;
  for (index = j = 0, len = array.length; j < len; index = ++j) {
    byte = array[index];
    array[index] = array[index] ^ 0xFF;
  }
  results = [];
  for (index = k = 0, len1 = array.length; k < len1; index = ++k) {
    byte = array[index];
    array[index] = array[index] + 1;
    if (array[index] > 255) {
      results.push(array[index] = 0);
    } else {
      break;
    }
  }
  return results;
};

convertLEBytesToString = function (buffer) {
  var array, result, sign, t;
  array = Array.prototype.slice.call(buffer, 0, buffer.length);
  if (isZero(array)) {
    return '0';
  } else {
    if (array[array.length - 1] & 0x80) {
      sign = '-';
      invert(array);
    } else {
      sign = '';
    }
    result = '';
    while (!isZero(array)) {
      t = getNextRemainder(array);
      result = t + result;
    }
    return sign + result;
  }
};

numberToInt64LE = function (num) {
  var buf, carry, hi, i, j, k, lo, negate, v;
  negate = num < 0;
  hi = Math.abs(num);
  lo = hi % 0x100000000;
  hi = hi / 0x100000000 | 0;
  buf = new Buffer(8);
  for (i = j = 0; j <= 7; i = ++j) {
    buf[i] = lo & 0xff;
    lo = i === 3 ? hi : lo >>> 8;
  }
  if (negate) {
    carry = 1;
    for (i = k = 0; k <= 7; i = ++k) {
      v = (buf[i] ^ 0xff) + carry;
      buf[i] = v & 0xff;
      carry = v >> 8;
    }
  }
  return buf;
};

module.exports.convertLEBytesToString = convertLEBytesToString;

module.exports.numberToInt64LE = numberToInt64LE;