// Generated by CoffeeScript 1.9.3
var OPTION, RpcRequestPayload, STATUS, WritableTrackingBuffer, typeByName, writeAllHeaders;

WritableTrackingBuffer = require('./tracking-buffer/tracking-buffer').WritableTrackingBuffer;

writeAllHeaders = require('./all-headers').writeToTrackingBuffer;

typeByName = require('./data-type').typeByName;

OPTION = {
  WITH_RECOMPILE: 0x01,
  NO_METADATA: 0x02,
  REUSE_METADATA: 0x04
};

STATUS = {
  BY_REF_VALUE: 0x01,
  DEFAULT_VALUE: 0x02
};

/*
  s2.2.6.5
 */

RpcRequestPayload = (function () {
  function RpcRequestPayload(request, txnDescriptor, options) {
    var base, base1, base2, buffer, i, len, optionFlags, outstandingRequestCount, param, parameter, ref, ref1, ref2, ref3, statusFlags;
    this.request = request;
    buffer = new WritableTrackingBuffer(500);
    this.procedure = this.request.sqlTextOrProcedure;
    if (options.tdsVersion >= '7_2') {
      outstandingRequestCount = 1;
      writeAllHeaders(buffer, txnDescriptor, outstandingRequestCount);
    }
    if (typeof this.procedure === 'string') {
      buffer.writeUsVarchar(this.procedure);
    } else {
      buffer.writeUShort(0xFFFF);
      buffer.writeUShort(this.procedure);
    }
    optionFlags = 0;
    buffer.writeUInt16LE(optionFlags);
    ref = this.request.parameters;
    for (i = 0, len = ref.length; i < len; i++) {
      parameter = ref[i];
      statusFlags = 0;
      if (parameter.output) {
        statusFlags |= STATUS.BY_REF_VALUE;
      }
      buffer.writeBVarchar('@' + parameter.name);
      buffer.writeUInt8(statusFlags);
      param = {
        value: parameter.value
      };
      if ((parameter.type.id & 0x30) === 0x20) {
        param.length = (ref1 = parameter.length) != null ? ref1 : typeof (base = parameter.type).resolveLength === "function" ? base.resolveLength(parameter) : void 0;
      }
      if (parameter.type.hasPrecision) {
        param.precision = (ref2 = parameter.precision) != null ? ref2 : typeof (base1 = parameter.type).resolvePrecision === "function" ? base1.resolvePrecision(parameter) : void 0;
      }
      if (parameter.type.hasScale) {
        param.scale = (ref3 = parameter.scale) != null ? ref3 : typeof (base2 = parameter.type).resolveScale === "function" ? base2.resolveScale(parameter) : void 0;
      }
      parameter.type.writeTypeInfo(buffer, param, options);
      parameter.type.writeParameterData(buffer, param, options);
    }
    this.data = buffer.data;
  }

  RpcRequestPayload.prototype.toString = function (indent) {
    indent || (indent = '');
    return indent + ("RPC Request - " + this.procedure);
  };

  return RpcRequestPayload;
})();

module.exports = RpcRequestPayload;